org.codehaus.jackson.map.deser.std

## Class CollectionDeserializer

- java.lang.Object
- - org.codehaus.jackson.map.JsonDeserializer<T>
  - - org.codehaus.jackson.map.deser.std.StdDeserializer<T>
    - - org.codehaus.jackson.map.deser.std.ContainerDeserializerBase<Collection<Object>>
      - - org.codehaus.jackson.map.deser.std.CollectionDeserializer

- All Implemented Interfaces:
    ResolvableDeserializer
  Direct Known Subclasses:
    CollectionDeserializer

      public class CollectionDeserializer
      extends ContainerDeserializerBase<Collection<Object>>
      implements ResolvableDeserializer

  Basic serializer that can take JSON "Array" structure and construct a `Collection` instance, with typed contents.

  Note: for untyped content (one indicated by passing Object.class as the type), `UntypedObjectDeserializer` is used instead. It can also construct `List`s, but not with specific POJO types, only other containers and primitives/wrappers.

  Since:
    1.9 (renamed from 'org.codehaus.jackson.map.deser.CollectionDeserializer)

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.codehaus.jackson.map.deser.std.StdDeserializer

      `StdDeserializer.BigDecimalDeserializer, StdDeserializer.BigIntegerDeserializer, StdDeserializer.BooleanDeserializer, StdDeserializer.ByteDeserializer, StdDeserializer.CharacterDeserializer, StdDeserializer.DoubleDeserializer, StdDeserializer.FloatDeserializer, StdDeserializer.IntegerDeserializer, StdDeserializer.LongDeserializer, StdDeserializer.NumberDeserializer, StdDeserializer.PrimitiveOrWrapperDeserializer<T>, StdDeserializer.ShortDeserializer, StdDeserializer.SqlDateDeserializer, StdDeserializer.StackTraceElementDeserializer`

    - ### Nested classes/interfaces inherited from class org.codehaus.jackson.map.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JavaType` | `_collectionType`
    `protected JsonDeserializer<Object>` | `_delegateDeserializer` Deserializer that is used iff delegate-based creator is to be used for deserializing from JSON Object.
    `protected JsonDeserializer<Object>` | `_valueDeserializer` Value deserializer.
    `protected ValueInstantiator` | `_valueInstantiator`
    `protected TypeDeserializer` | `_valueTypeDeserializer` If element instances have polymorphic type information, this is the type deserializer that can handle it

    - ### Fields inherited from class org.codehaus.jackson.map.deser.std.StdDeserializer

      `_valueClass`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `CollectionDeserializer(CollectionDeserializer src)` Copy-constructor that can be used by sub-classes to allow copy-on-write styling copying of settings of an existing instance.
    `protected` | `CollectionDeserializer(JavaType collectionType, JsonDeserializer<Object> valueDeser, TypeDeserializer valueTypeDeser, Constructor<Collection<Object>> defCtor)` Deprecated. Since 1.9, use variant that takes ValueInstantiator
    `` | `CollectionDeserializer(JavaType collectionType, JsonDeserializer<Object> valueDeser, TypeDeserializer valueTypeDeser, ValueInstantiator valueInstantiator)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Collection<Object>` | `deserialize(JsonParser jp, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
    `Collection<Object>` | `deserialize(JsonParser jp, DeserializationContext ctxt, Collection<Object> result)` Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer.
    `Object` | `deserializeWithType(JsonParser jp, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.
    `JsonDeserializer<Object>` | `getContentDeserializer()` Accesor for deserializer use for deserializing content values.
    `JavaType` | `getContentType()` Accessor for declared type of contained value elements; either exact type, or one of its supertypes.
    `void` | `resolve(DeserializationConfig config, DeserializerProvider provider)` Method called to finalize setup of this deserializer, after deserializer itself has been registered.

    - ### Methods inherited from class org.codehaus.jackson.map.deser.std.StdDeserializer

      `_parseBoolean, _parseBooleanFromNumber, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, findDeserializer, getValueClass, getValueType, handleUnknownProperty, isDefaultSerializer, parseDouble, reportUnknownProperty`

    - ### Methods inherited from class org.codehaus.jackson.map.JsonDeserializer

      `getEmptyValue, getNullValue, unwrappingDeserializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _collectionType

          protected final JavaType _collectionType

    - #### _valueDeserializer

          protected final JsonDeserializer<Object> _valueDeserializer

      Value deserializer.

    - #### _valueTypeDeserializer

          protected final TypeDeserializer _valueTypeDeserializer

      If element instances have polymorphic type information, this is the type deserializer that can handle it

    - #### _valueInstantiator

          protected final ValueInstantiator _valueInstantiator

      Since:
        1.9

    - #### _delegateDeserializer

          protected JsonDeserializer<Object> _delegateDeserializer

      Deserializer that is used iff delegate-based creator is to be used for deserializing from JSON Object.

  - ### Constructor Detail

    - #### CollectionDeserializer

          @Deprecated
          protected CollectionDeserializer(JavaType collectionType,
                                           JsonDeserializer<Object> valueDeser,
                                           TypeDeserializer valueTypeDeser,
                                           Constructor<Collection<Object>> defCtor)

      Deprecated. Since 1.9, use variant that takes ValueInstantiator

    - #### CollectionDeserializer

          public CollectionDeserializer(JavaType collectionType,
                                JsonDeserializer<Object> valueDeser,
                                TypeDeserializer valueTypeDeser,
                                ValueInstantiator valueInstantiator)

      Since:
        1.9

    - #### CollectionDeserializer

          protected CollectionDeserializer(CollectionDeserializer src)

      Copy-constructor that can be used by sub-classes to allow copy-on-write styling copying of settings of an existing instance.
      Since:
        1.9

  - ### Method Detail

    - #### resolve

          public void resolve(DeserializationConfig config,
                     DeserializerProvider provider)
                       throws JsonMappingException

      Method called to finalize setup of this deserializer, after deserializer itself has been registered. This is needed to handle recursive and transitive dependencies.
      Specified by:
        `resolve` in interface `ResolvableDeserializer`
        `provider` - Provider that has constructed deserializer this method is called on.
      Throws:
        `JsonMappingException`

    - #### getContentType

          public JavaType getContentType()

      Description copied from class: `ContainerDeserializerBase`
      Accessor for declared type of contained value elements; either exact type, or one of its supertypes.
      Specified by:
        `getContentType` in class `ContainerDeserializerBase<Collection<Object>>`

    - #### getContentDeserializer

          public JsonDeserializer<Object> getContentDeserializer()

      Description copied from class: `ContainerDeserializerBase`
      Accesor for deserializer use for deserializing content values.
      Specified by:
        `getContentDeserializer` in class `ContainerDeserializerBase<Collection<Object>>`

    - #### deserialize

          public Collection<Object> deserialize(JsonParser jp,
                                       DeserializationContext ctxt)
                                         throws IOException,
                                                JsonProcessingException

      Description copied from class: `JsonDeserializer`
      Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

      Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker. Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

      Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

      Specified by:
        `deserialize` in class `JsonDeserializer<Collection<Object>>`
      Parameters:
        `jp` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserializer value
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### deserialize

          public Collection<Object> deserialize(JsonParser jp,
                                       DeserializationContext ctxt,
                                       Collection<Object> result)
                                         throws IOException,
                                                JsonProcessingException

      Description copied from class: `JsonDeserializer`
      Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer. Method is not necessarily used for all supported types; most commonly it is used for Collections and Maps.

      Default implementation just throws `UnsupportedOperationException`, to indicate that types that do not explicitly add support do not expect to get the call.

      Overrides:
        `deserialize` in class `JsonDeserializer<Collection<Object>>`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### deserializeWithType

          public Object deserializeWithType(JsonParser jp,
                                   DeserializationContext ctxt,
                                   TypeDeserializer typeDeserializer)
                                     throws IOException,
                                            JsonProcessingException

      Description copied from class: `StdDeserializer`
      Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.
      Overrides:
        `deserializeWithType` in class `StdDeserializer<Collection<Object>>`
        `typeDeserializer` - Deserializer to use for handling type information
      Throws:
        `IOException`
        `JsonProcessingException`